import { EventEmitter } from '../../stencil-public-runtime';
import { GetNotificationsReturnData } from '../../api/methods/types';
export declare class NutsPopover {
    /**
     * Language code of the content
     */
    language: string;
    /**
     * Unique ID of the user receiving notifications
     */
    userId: string;
    /**
     * Unique ID of the operator domain
     */
    operatorId: string;
    /**
     * Token used to authenticate notification transactions
     */
    token: string;
    /**
     * The sessionID of the user
     */
    sessionId: string;
    /**
     * Endpoint used for notification transactions
     */
    backendUrl: string;
    /**
     * The count of unseen notifications
     */
    unseenCount: number;
    /**
     * Custom styling URL
     */
    clientStylingUrl: string;
    /**
     * Decides the behaviour of the notification onClick
     */
    notificationAction: string;
    /**
     * Custom styling string
     */
    clientStyling: string;
    /**
     * Translations via URL
     */
    translationUrl: string;
    private notifications;
    private isLoading;
    private showMarkAll;
    private currentPage;
    private stylingContainer;
    private baseUrl;
    allNotificationsRead: EventEmitter<any>;
    messageDeteledHandler(event: CustomEvent<any>): void;
    newNotificationHandler(event: CustomEvent<any>): void;
    unseenCountHandler(newValue: number): void;
    handleNewTranslations(): void;
    componentWillLoad(): Promise<void>;
    updateNotificationsDataAfterPageChange: (getNotificationsData: GetNotificationsReturnData) => void;
    nextPage: () => Promise<void>;
    prevPage: () => void;
    setClientStyling: () => void;
    setClientStylingURL: () => void;
    connectedCallback(): void;
    markAllNotificationsAsRead: () => Promise<void>;
    assignRefToStylingContainer: (ref: HTMLElement) => void;
    render(): any;
}
